VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "frmMain"
   ClientHeight    =   4425
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   6435
   LinkTopic       =   "frmMain"
   ScaleHeight     =   4425
   ScaleWidth      =   6435
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton cmdSetToLargerSize 
      Caption         =   "Set to 800x600"
      Height          =   495
      Left            =   720
      TabIndex        =   2
      Top             =   1320
      Width           =   1935
   End
   Begin VB.CheckBox chkHandleWindowPosChanged 
      Caption         =   "Handle WM_WINDOWPOSCHANGED"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   3255
   End
   Begin VB.CommandButton cmdSetToSmallerSize 
      Caption         =   "Set to 200x350"
      Height          =   495
      Left            =   720
      TabIndex        =   0
      Top             =   600
      Width           =   1935
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

  Private Const MAXHEIGHT As Long = 500
  Private Const MAXWIDTH As Long = 600
  Private Const MINHEIGHT As Long = 200
  Private Const MINWIDTH As Long = 300


  Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
  End Type

  Private Type WINDOWPOS
    hWnd As Long
    hWndInsertAfter As Long
    x As Long
    y As Long
    cx As Long
    cy As Long
    Flags As Long
  End Type


  Implements ISubclassedWindow


Private Sub cmdSetToLargerSize_Click()
  Me.Move Me.Left, Me.Top, Me.ScaleX(800, ScaleModeConstants.vbPixels, Me.ScaleMode), Me.ScaleY(600, ScaleModeConstants.vbPixels, Me.ScaleMode)
End Sub

Private Sub cmdSetToSmallerSize_Click()
  Me.Move Me.Left, Me.Top, Me.ScaleX(200, ScaleModeConstants.vbPixels, Me.ScaleMode), Me.ScaleY(350, ScaleModeConstants.vbPixels, Me.ScaleMode)
End Sub

Private Sub Form_Load()
  If Not SubclassWindow(Me.hWnd, Me, EnumSubclassID.escidFrmMain) Then
    Debug.Print "Subclassing failed!"
  End If
End Sub

Private Sub Form_Resize()
  Me.Caption = "Size: " & CStr(Me.ScaleX(Me.Width, Me.ScaleMode, ScaleModeConstants.vbPixels)) & "x" & CStr(Me.ScaleY(Me.Height, Me.ScaleMode, ScaleModeConstants.vbPixels))
End Sub

Private Sub Form_Unload(Cancel As Integer)
  If Not UnSubclassWindow(Me.hWnd, EnumSubclassID.escidFrmMain) Then
    Debug.Print "UnSubclassing failed!"
  End If
End Sub

Private Function ISubclassedWindow_HandleMessage(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long, ByVal eSubclassID As EnumSubclassID, bCallDefProc As Boolean) As Long
  Dim lRet As Long

  On Error GoTo StdHandler_Error
  Select Case eSubclassID
    Case EnumSubclassID.escidFrmMain
      lRet = HandleMessage_Form(hWnd, uMsg, wParam, lParam, bCallDefProc)
    Case Else
      Debug.Print "frmMain.ISubclassedWindow_HandleMessage: Unknown Subclassing ID " & CStr(eSubclassID)
  End Select

StdHandler_Ende:
  ISubclassedWindow_HandleMessage = lRet
  Exit Function

StdHandler_Error:
  Debug.Print "Error in frmMain.ISubclassedWindow_HandleMessage (SubclassID=" & CStr(eSubclassID) & ": ", Err.Number, Err.Description
  Resume StdHandler_Ende
End Function

Private Function HandleMessage_Form(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long, bCallDefProc As Boolean) As Long
  Const WM_SIZING = &H214
  Const WM_WINDOWPOSCHANGED = &H47
  Const WMSZ_BOTTOMLEFT = 7
  Const WMSZ_LEFT = 1
  Const WMSZ_TOP = 3
  Const WMSZ_TOPLEFT = 4
  Const WMSZ_TOPRIGHT = 5
  Dim lRet As Long
  Dim tRect As RECT
  Dim tWindowPos As WINDOWPOS

  On Error GoTo StdHandler_Error
  Select Case uMsg
    Case WM_SIZING
      CopyMemory VarPtr(tRect), lParam, LenB(tRect)
      If tRect.Right - tRect.Left < MINWIDTH Then
        Select Case wParam
          Case WMSZ_TOPLEFT, WMSZ_LEFT, WMSZ_BOTTOMLEFT
            tRect.Left = tRect.Right - MINWIDTH
          Case Else
            tRect.Right = tRect.Left + MINWIDTH
        End Select
      ElseIf tRect.Right - tRect.Left > MAXWIDTH Then
        Select Case wParam
          Case WMSZ_TOPLEFT, WMSZ_LEFT, WMSZ_BOTTOMLEFT
            tRect.Left = tRect.Right - MAXWIDTH
          Case Else
            tRect.Right = tRect.Left + MAXWIDTH
        End Select
      End If
      If tRect.Bottom - tRect.Top < MINHEIGHT Then
        Select Case wParam
          Case WMSZ_TOPLEFT, WMSZ_TOP, WMSZ_TOPRIGHT
            tRect.Top = tRect.Bottom - MINHEIGHT
          Case Else
            tRect.Bottom = tRect.Top + MINHEIGHT
        End Select
      ElseIf tRect.Bottom - tRect.Top > MAXHEIGHT Then
        Select Case wParam
          Case WMSZ_TOPLEFT, WMSZ_TOP, WMSZ_TOPRIGHT
            tRect.Top = tRect.Bottom - MAXHEIGHT
          Case Else
            tRect.Bottom = tRect.Top + MAXHEIGHT
        End Select
      End If
      CopyMemory lParam, VarPtr(tRect), LenB(tRect)

    Case WM_WINDOWPOSCHANGED
      If chkHandleWindowPosChanged.Value = vbChecked Then
        CopyMemory VarPtr(tWindowPos), lParam, LenB(tWindowPos)
        If tWindowPos.cx < MINWIDTH Then
          On Error Resume Next
          Me.Width = ScaleX(MINWIDTH, ScaleModeConstants.vbPixels, Me.ScaleMode)
        ElseIf tWindowPos.cx > MAXWIDTH Then
          On Error Resume Next
          Me.Width = ScaleX(MAXWIDTH, ScaleModeConstants.vbPixels, Me.ScaleMode)
        End If
        If tWindowPos.cy < MINHEIGHT Then
          On Error Resume Next
          Me.Height = ScaleY(MINHEIGHT, ScaleModeConstants.vbPixels, Me.ScaleMode)
        ElseIf tWindowPos.cy > MAXHEIGHT Then
          On Error Resume Next
          Me.Height = ScaleY(MAXHEIGHT, ScaleModeConstants.vbPixels, Me.ScaleMode)
        End If
      End If
  End Select

StdHandler_Ende:
  HandleMessage_Form = lRet
  Exit Function

StdHandler_Error:
  Debug.Print "Error in frmMain.HandleMessage_Form: ", Err.Number, Err.Description
  Resume StdHandler_Ende
End Function
